const express = require("express");
const { connection, key } = require("../dbcon/db");
const bodyparser = require("body-parser");
var app = express();

/**********************
 Search Process Start 
***********************/

/* Route  : To Search by NPA ThinQ */
app.get('/searchthinqbynpa', bodyparser.json(), (req, res) => {
    const queryData = req.query;
    let condition = "`npa` = '"+queryData.npa+"'";
    console.log("Requested Data for /searchthinqbynpa :: ", queryData);
    thinqcommon(req, res, queryData.quantity, condition);
});
/* Route  : To Search by NPA and NXX ThinQ */
app.get('/searchthinqbynpanxx', bodyparser.json(), (req, res) => {
    const queryData = req.query;
    let condition = "`npa` = '"+queryData.npa+"' AND `nxx` = '"+queryData.nxx+"'";
    console.log("Requested Data for /searchthinqbynpanxx :: ", queryData);
    thinqcommon(req, res, queryData.quantity, condition);
});
/* Route  : To Search by State and RateCenter */
app.get('/searchthinqbyrate', bodyparser.json(), (req, res) => {
    const queryData = req.query;
    let condition = "`state` = '"+queryData.state+"' AND `ratecenter` = '"+queryData.rateCenter+"'";
    console.log("Requested Data for /searchthinqbyrate :: ", queryData);
    thinqcommon(req, res, queryData.quantity, condition);
});

function thinqcommon(req, res, qty, condition){
    let qry = "SELECT CONCAT('1', `did`) AS id, CONCAT('(', SUBSTRING(did, 1, 3), ') ', SUBSTRING(did, 4, 3), '-', SUBSTRING(did, 7, 4)) AS didSummary, `ratecenter` rate_center, state, 0 AS thinqTier FROM `did_buy` WHERE "+condition+" AND `type`='NN' LIMIT " + qty;
    console.log("DID Query",qry);
    connection.execute(qry, (err, rows) => {
        if (err==1) {
            if (rows.length > 0) {
                res.send({ status: 200, message: "DID Fetched Successfully", dids:rows });   
            } else {
                res.send({ status: 404, message: "DID Data Does Not Exist!", dids:[]});
            }
        }
        else {
            res.send({ status: 500, message: "Query Execution Failed" });   
        }
    });
}

/* Route  : To Search by NPA and NXX Inteliquent */
app.post('/inteliquent/tnInventory', bodyparser.json(), (req, res) => {
    const postData = req.body;
    let condition = '';
    if(postData.province && postData.rateCenter){
        condition = "`state` = '"+postData.province+"' AND `ratecenter` = '"+postData.rateCenter+"'";
    }
    else{
        const segments = extractSegments(postData.tnMask);
        if(segments.npa)
            condition += "`npa` = '"+segments.npa+"'";
        if(segments.nxx)
            condition += " AND `nxx` = '"+segments.nxx+"'";
    }
    intelicommon(req, res, postData.quantity, condition);    
    console.log("Requested Data for /inteliquent/tnInventory :: ", condition);
    
});

function intelicommon(req, res, qty, condition){
    let qry = "SELECT `did` AS telephoneNumber, `ratecenter` AS rateCenter, `state` AS province, 'Tier1' AS rateCenterTier, 'LATA1' AS lata, 'CC1' AS countryCode, 'true' AS cnamAllowed, 'false' AS dlAllowed, 'true' AS e911Allowed, 'false' AS msgAllowed, 'City1' AS city FROM `did_buy` WHERE "+condition+" AND `type`='NN' LIMIT " + qty;
    console.log("DID Query",qry);
    connection.execute(qry, (err, rows) => {
        if (err==1) {
            if (rows.length > 0) {
                res.send({ statusCode: 200, message: "DID Fetched Successfully", tnResult:rows });   
            } else {
                res.send({ statusCode: 404, message: "DID Data Does Not Exist!", tnResult:[]});
            }
        }
        else {
            res.send({ status: 500, message: "Query Execution Failed" });              
        }
    });
}
/**********************
 Search Process End 
***********************/

/**********************
 Buy Process Start 
***********************/

/* Route  : To Order Create from ThinQ */
app.post('/thinqordercreate', bodyparser.json(), (req, res) => {
    const postData = req.body;
    console.log("Requested Data for /thinqordercreate :: ", postData);
    let did = postData.order.tns[0].did;
    if(did){
        let qry = "SELECT `did` FROM `did_buy` WHERE `did`="+did.trim()+" LIMIT 1";
        console.log("DID Check Query",qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if(rows.length > 0){
                    const ticketNumber = generateTicket();
                    if(ticketNumber){
                        console.log({ code: 200, message: "Order created successfully", id:ticketNumber });
                        res.send({ code: 200, message: "Order created successfully", id:ticketNumber });  
                    }
                    else{
                        console.log({code: 412, message: "DID "+did+"  order not created", description: ''});                        
                        res.send({code: 412, message: "DID "+did+"  order not created", description: ''});
                    }            
                }
                else {
                    console.log({code: 413, message: "DID "+did+" is not available", description: ''});
                    res.send({code: 413, message: "DID "+did+" is not available", description: ''});
                }
            }
            else{
                console.log({code: 413, message: "Something went wrong with Connection!", description: ''});
                res.send({code: 413, message: "Something went wrong with Connection!", description: ''}); 
            }
        });
    }
    else{
        res.send({code: 415, message: "Invalid DID!", description: ''}); 
    }    
});

/* Route  : To Order Complete from ThinQ */
app.post('/thinqordercomplete/:orderid', bodyparser.json(), (req, res) => {
    const prmData = req.params;
    console.log("Requested Data for /thinqordercomplete :: ", prmData);
    let orderId = prmData.orderid;
    if(orderId){
        res.send({code: 200, message: "Order Completed successfully", id : orderId, status: 'completed'});  
    }
    else{
        res.send({code: 404, message: "Origination order "+orderId+" does not exist", description: ''}); 
    }
});

/* Route  : To Order NN DID from Inteliquent */
app.post('/inteliquent/tnOrder', bodyparser.json(), (req, res) => {
    const postData = req.body;
    let did = postData.tnOrder.tnList.tnItem[0].tn;
    console.log("Requested Data for /inteliquent/tnOrder :: ", postData);
    if(did){
        let qry = "SELECT `did` FROM `did_buy` WHERE `did`="+did.trim()+" LIMIT 1";
        console.log("DID Check Query",qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if(rows.length > 0){
                    res.send({statusCode:200, status:"Success", orderId:generateTicket()});        
                }
                else{
                    res.send({statusCode:412, status:"Invalid trunk group submitted for:"+did+""});
                }
            }
            else{
                res.send({statusCode: 413, status: "Something went wrong with Connection!"}); 
            }
        });
    }
    else{
        res.send({message:"This API cannot be accessed from this IP Address",status:"Forbidden",statusCode:"403002",timestamp: getFormattedDate()}); 
    }    
});

/*****************
 Buy Process End 
*****************/

/******************
  OSR Process Start
******************/
/* Route  : To Import Number on OSR */
app.put('/osr/:number', express.text({ type: '*/*' }), (req, res) => {
    const prmData = req.params;
    console.log("Requested Data for /osr update :: ", prmData);
    let number = prmData.number;
    if(number){
        let did= number.trim();
        let qry = "SELECT `did` FROM `did_buy` WHERE `did`="+did.slice(-10)+" LIMIT 1";
        console.log("DID Check Query",qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if(rows.length > 0){
                    res.send(JSON.stringify({status: 200, message: "Success"}));
                }
                else{
                    res.send(JSON.stringify({status:412, status:"Number [" + number.slice(-10) + "] not available in our Inventory System"}));
                }
            }
            else{
                res.send(JSON.stringify({status: 413, status: "Something went wrong with Connection!"})); 
            }
        });
    }
    else{
        res.send({status: 404, message: "Invalid DID!"}); 
    }
});

/* Route  : To Delete Number from OSR */
app.delete('/osr/:number', express.text({ type: '*/*' }), (req, res) => {
    const prmData = req.params;
    let number = prmData.number;
    console.log("Requested Data for /osr delete :: ", prmData);
    if (number) {
        let did= number.trim();
        let qry = "SELECT `did` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    res.status(200).send(JSON.stringify({status: 200, message: "Success"}));
                } else {
                    res.status(412).send(JSON.stringify({status: 412, status: "Number [" + number.slice(-10) + "] not available in our Inventory System"}));
                }                
            } else {
                console.error("Database Connection Error:", err);
                res.status(500).send(JSON.stringify({status: 500, status: "Something went wrong with Connection!"}));   
            }
        });
    } else {
        res.status(404).send({status: 404, message: "Invalid DID!"}); 
    }
});
/******************
  OSR Process End
******************/

/*********************
  Sinch Process Start
*********************/
/* Route  : To Import Number on SINCH */
app.post('/sinch/importedNumbers/', bodyparser.json(), (req, res) => {
    const postData = req.body;
    console.log("Requested Data for /sinch/importedNumbers :: ", postData);
    let number = postData.phone_number;
    if (number) {
        let did= number.trim();
        let qry = "SELECT `did`, `sinch_status` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    if(rows[0].sinch_status==1){
                        res.send(JSON.stringify({error:{status:"ALREADY_EXISTS", smsConfiguration:''}}));
                    }
                    else if(rows[0].sinch_status==0){
                        res.send(JSON.stringify({error:'',smsConfiguration:{scheduledProvisioning:''}}));
                    }
                    else if(rows[0].sinch_status!==0 && rows[0].sinch_status!==1){
                        res.send(JSON.stringify({error:'',smsConfiguration:{scheduledProvisioning:{status:"CONFLICT"}}}));
                    }
                } else {
                    res.send(JSON.stringify({error:'',smsConfiguration:{scheduledProvisioning:''}}));
                }
            } else {
                console.error("Database Connection Error:", err);
                res.send(JSON.stringify({error:{status:"ERROR_CONNECT"}, smsConfiguration:''}));
            }
        });
    } else {
        res.send(JSON.stringify({error:{status:"INVALID_REQUEST", smsConfiguration:''}}));
    }
});
/* Route  : To Delete Number from SINCH */
app.delete('/sinch/importedNumbers/:number', (req, res) => {
    const prmData = req.params;
    console.log("Requested Data for /sinch/importedNumbers delete :: ", prmData);
    let number = prmData.number;
    if (number) {
        let did= number.trim();
        let qry = "SELECT `did`, `disconnect_did_status` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    res.send(JSON.stringify({}));
                } else {
                    res.send(JSON.stringify({status: 412, error:{ code:404 }}));
                }                
            } else {
                console.error("Database Connection Error:", err);
                res.send(JSON.stringify({status: 500, error:{ code:403, message:"DID disconnect failed from SINCH" }}));
            }
        });
    } else {
        res.send({status: 404, message: "Invalid DID!"}); 
    }
});
/*********************
  SInch Process End
*********************/

/************************
  Syniverse Process Start
************************/
/* Route  : To Import Number on SYNIVERSE */
app.post('/syniv/campaigns/:campaign/longcodes/:number', express.text({ type: '*/*' }), (req, res) => {
    const prmData = req.params;
    console.log("Requested Data for /syniv Import :: ", prmData);

    let number = prmData.number;
    if (number) {
        let did= number.trim();
        let qry = "SELECT `did`, `sinch_status` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    if(rows[0].sinch_status ==0){
                        res.send(JSON.stringify({status: 'ACCEPTED', error:200 }));
                    }else {
                        res.send(JSON.stringify({status: 'CONFLICT', error:203 }));
                    }
                } else {
                    res.send(JSON.stringify({status: 'ACCEPTED', error:200 }));
                }
            } else {
                console.error("Database Connection Error:", err);
                res.send(JSON.stringify({status: 'BAD_REQUEST', error:{ code:404 }}));   
            }
        });
    } else {
        res.send(JSON.stringify({status: 'INVALID_DID', error:404 }));
    }
});

/* Route  : To Delete Number from SYNIVERSE */
app.delete('/syniv/campaigns/:campaign/longcodes/:number', (req, res) => {
    const prmData = req.params;
    console.log("Requested Data for /syniv delete :: ", prmData);
    let number = prmData.number;
    if (number) {
        let did= number.trim();
        let qry = "SELECT `did`, `sinch_status` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    if(rows[0].sinch_status ==1){
                        res.send(JSON.stringify({status: 'ACCEPTED', error:200 }));
                    }else {
                        res.send(JSON.stringify({status: 'CONFLICT', error:203 }));
                    }
                } else {
                    res.send(JSON.stringify({status: 'ACCEPTED', error:200 }));
                } 
            } else {
                console.error("Database Connection Error:", err);
                res.send(JSON.stringify({status: 'BAD_REQUEST', error:{ code:404 }}));  
            }
        });
    } else {
        res.send(JSON.stringify({status: 'INVALID_DID', error:404 }));
    }
});
/***********************
  Syniverse Process End
***********************/

/*************************
  DIsconnect Process Start
*************************/
/* Route  : To Order Complete from ThinQ */
app.post('/thinqdisconnect', bodyparser.json(), (req, res) => {
    const postData = req.body;
    console.log("Requested Data for /thinqdisconnect :: ", postData);
    let number = postData.dids[0];
    if(number){
        let did= number.trim();
        let qry = "SELECT `did` FROM `did_buy` WHERE `did`=" + did.slice(-10) + " LIMIT 1";
        console.log("DID Check Query:", qry);
        connection.execute(qry, (err, rows) => {
            if (err==1) {
                if (rows.length > 0) {
                    res.send({code: 200, status: "completed", message: "Order Completed successfully"});  
                } 
                else {
                    res.send({code: 403, status: "notavailable", message: "DID "+number+" Not Available in Our Inventory"});
                }
            } else {
                console.error("Database Connection Error:", err);
                res.send({code: 500, status: "failed", message: "DID Disconnect Failed"});   
            }
        });
    }
    else{
        res.send({code: 401, message: "Unauthorized", description:""}); 
    }
});
/* Route  : To Disconnect DID from Inteliquent */
app.post('/inteliquent/tnDisconnect', bodyparser.json(), (req, res) => {
    const postData = req.body;
    let did = postData.tnList.tnItem[0].tn;
    console.log("Requested Data for /inteliquent/tnOrder :: ", postData);
    if(did > 0){
        res.send({statusCode:200, status:"Success"});        
    }
    else{
        res.send({statusCode:425, status:"Invalid DID "+did+""});
    } 
});
/***********************
  Disconnect Process End
************************/

/********************
   Common Functions 
********************/

function getFormattedDate() {
    const date = new Date();
    const year = date.getFullYear();
    const month = String(date.getMonth() + 1).padStart(2, '0'); 
    const day = String(date.getDate()).padStart(2, '0');
    const hours = String(date.getHours()).padStart(2, '0');
    const minutes = String(date.getMinutes()).padStart(2, '0');
    const seconds = String(date.getSeconds()).padStart(2, '0');
    const milliseconds = String(date.getMilliseconds()).padStart(3, '0');
    const offset = -date.getTimezoneOffset();
    const sign = offset >= 0 ? "+" : "-";
    const offsetHours = String(Math.floor(Math.abs(offset) / 60)).padStart(2, '0');
    const offsetMinutes = String(Math.abs(offset) % 60).padStart(2, '0');
    return `${year}-${month}-${day}T${hours}:${minutes}:${seconds}.${milliseconds}${sign}${offsetHours}${offsetMinutes}`;
}

function generateTicket() {
    /* Generate a random 7-digit number */
    const ticket = Math.floor(1000000 + Math.random() * 9000000);
    return ticket;
}
function extractSegments(phoneNumber) {
    const regex = /^(\d{1,3})(\d{3})?/;
    const match = phoneNumber.match(regex);
    if (match) {
      const npa = match[1];
      const nxx = match[2] || '';
      return { npa, nxx};
    }
    return { npa: '', nxx: ''};
  }


app.listen(3004, () => {
    console.log("Server is Connected at Port :: 3004");
}); 